Package org.codehaus.groovy.vmplugin.v8

# Enum Class IndyInterface.CallType

java.lang.Object
java.lang.Enum<IndyInterface.CallType>
org.codehaus.groovy.vmplugin.v8.IndyInterface.CallType

All Implemented Interfaces:
  `Serializable`, `Comparable<IndyInterface.CallType>`, `Constable`

Enclosing class:
  IndyInterface

public static enum IndyInterface.CallType extends Enum<IndyInterface.CallType>
Enum for easy differentiation between call types.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `CAST`
  Cast invocation type.
  `COMPOUND_ASSIGN`
  Compound-assignment invocation type (GEP-15), e.g.
  `GET`
  Get property invocation type.
  `INIT`
  Constructor invocation type.
  `INTERFACE`
  Interface method invocation type.
  `METHOD`
  Method invocation type.
  `SET`
  Set property invocation type.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static IndyInterface.CallType`
  `fromCallSiteName(String callSiteName)`
  Resolves a call type by its bootstrap call-site name.
  `String`
  `getCallSiteName()`
  Returns the name of the call site type
  `int`
  `getOrderNumber()`
  Returns the ordinal used as the call-site dispatch id.
  `static IndyInterface.CallType`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static IndyInterface.CallType[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### METHOD

    public static final IndyInterface.CallType METHOD
    Method invocation type.

  - ### INIT

    public static final IndyInterface.CallType INIT
    Constructor invocation type.

  - ### GET

    public static final IndyInterface.CallType GET
    Get property invocation type.

  - ### SET

    public static final IndyInterface.CallType SET
    Set property invocation type.

  - ### CAST

    public static final IndyInterface.CallType CAST
    Cast invocation type.

  - ### INTERFACE

    public static final IndyInterface.CallType INTERFACE
    Interface method invocation type.

  - ### COMPOUND_ASSIGN

    public static final IndyInterface.CallType COMPOUND_ASSIGN
    Compound-assignment invocation type (GEP-15), e.g. `+=`. The bootstrap `name` carries `assignName` and `baseName` packed as `assignName + NAME_SEPARATOR + baseName` (NUL-separated); resolution is delegated to `IndyCompoundAssign`.

- ## Method Details

  - ### values

    public static IndyInterface.CallType[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static IndyInterface.CallType valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getCallSiteName

    public String getCallSiteName()
    Returns the name of the call site type

  - ### fromCallSiteName

    public static IndyInterface.CallType fromCallSiteName(String callSiteName)
    Resolves a call type by its bootstrap call-site name.
    Parameters:
      `callSiteName` - the bootstrap call-site name
    Returns:
      the matching call type, or `null` if none matches

  - ### getOrderNumber

    public int getOrderNumber()
    Returns the ordinal used as the call-site dispatch id.
    Returns:
      the call-type order number